//  File name: $HeadURL: https://www.rheinahrcampus.de/svn/repos/predict4a/pLib/src/qFSLProcessing.cpp $
//  Revision: $Revision: 54 $
//  Last modified: $Date: 2012-06-01 09:34:24 +0200 (Fr, 01 Jun 2012) $
//  Last modified by: $Author: neeb $

/*
 * qFSLProcessing.cpp
 *
 *  Created on: 23.03.2012
 *      Author: neeb

	Copyright 2012 Heiko Neeb

    This file is part of PREDICT-MS (Professional Remagen Diagnostic Image Calculation Tool for MS).

    PREDICT-MS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    PREDICT-MS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with "predict".  If not, see <http://www.gnu.org/licenses/>.

	PREDICT-MS is designed to be used for scientific purposes only. Do NOT
	base any diagnosis on the results obtained with this program

	The software is based on the following work which the authors kindly ask to reference in
	any scientific work which is based on PREDICT-MS or parts of it:

	V. Tonkova, V. Arhelger, J. Schenk, H. Neeb. Rapid Myelin Water Content Mapping on Clinical MR Systems.
	Z Med Phys (2012): http://dx.doi.org/10.1016/j.zemedi.2011.09.005

	H. Neeb, V. Ermer, T. Stocker, N.J. Shah. Fast quantitative mapping of absolute water content
	with full brain coverage. NeuroImage (2008). 42(3): 10941109

 */

#include "qFSLProcessing.h"
#include <iostream>
#include "stdlib.h"

qFSLProcessing::qFSLProcessing() {
	// TODO Auto-generated constructor stub

}

qFSLProcessing::~qFSLProcessing() {
	// TODO Auto-generated destructor stub
}


void qFSLProcessing::startFSLBatch(std::string Folder) {

	std::string cmd;

	// bet /home/neeb/bv/data/MSKO/KOMS0004/NIFTI/gre_highflip.nii /home/neeb/bv/data/MSKO/KOMS0004/NIFTI/gre_highflip_Brain -f 0.35
	cmd = "bet "+Folder + "NIFTI/gre_highflip.nii" + " " + Folder + "NIFTI/gre_highflip_Brain -f 0.35";
	std::cout << cmd << std::endl;
	system(cmd.c_str());

	// flirt -in /home/neeb/bv/data/MSKO/KOMS0004/NIFTI/gre_highflip_Brain.nii.gz -ref /usr/share/fsl/data/standard/MNI152_T1_1mm_brain -dof 12 -cost corratio -out /home/neeb/bv/data/MSKO/KOMS0004/NIFTI/flirted_grehighflip_Brain -omat /home/neeb/bv/data/MSKO/KOMS0004/NIFTI/gre_highflip_to_MNI152.mat
	cmd = "flirt -in "+Folder+"/NIFTI/gre_highflip_Brain.nii.gz -ref /usr/local/fsl/data/standard/MNI152_T1_1mm_brain -dof 12 -cost corratio -out ";
	cmd += Folder + "NIFTI/flirted_grehighflip_Brain -omat "+ Folder +"NIFTI/gre_highflip_to_MNI152.mat";
	std::cout << cmd << std::endl;
	system(cmd.c_str());

	// fnirt
	cmd = "fnirt --in="+Folder+"/NIFTI/gre_highflip.nii --aff="+Folder+"/NIFTI/gre_highflip_to_MNI152.mat --config=/usr/local/fsl/config/Patient_to_MNI_Final.cnf";
	cmd += " --cout="+Folder+"/NIFTI/coef_grehigh_to_MNI152 --iout="+Folder+"NIFTI/fnirted_grehighflip --jout=";
	cmd += Folder+"NIFTI/jac_grehigh_to_MNI152 --jacrange=0.1,10";
	std::cout << cmd << std::endl;
	system(cmd.c_str());

	// applywarp -i gre_highflip.nii -r /usr/share/fsl/data/standard/MNI152_T1_1mm -o /home/neeb/bv/data/MSKO/KOMS0004/NIFTI/HD_fnirted_grehighflip
	cmd = "applywarp -i "+Folder+"NIFTI/gre_highflip.nii -r /usr/local/fsl/data/standard/MNI152_T1_1mm -o "+Folder+"NIFTI/HD_fnirted_grehighflip";
	std::cout << cmd << std::endl;
	//system(cmd.c_str());

	// fnirtfileutils --in=/home/neeb/bv/data/MSKO/KOMS0004/NIFTI/coef_grehigh_to_MNI152 --ref=/usr/share/fsl/data/standard/MNI152_T1_1mm --out=/home/neeb/bv/data/MSKO/KOMS0004/NIFTI/field_grehigh_to_MNI152_nonlinear_only
	cmd = "fnirtfileutils --in="+Folder+"NIFTI/coef_grehigh_to_MNI152 --ref=/usr/local/fsl/data/standard/MNI152_T1_1mm --out=";
	cmd += Folder+"NIFTI/field_grehigh_to_MNI152_nonlinear_only";
	std::cout << cmd << std::endl;
	system(cmd.c_str());

	// fnirtfileutils --in=/home/neeb/bv/data/MSKO/KOMS0004/NIFTI/coef_grehigh_to_MNI152 --ref=/usr/share/fsl/data/standard/MNI152_T1_1mm --withaff --out=/home/neeb/bv/data/MSKO/KOMS0004/NIFTI/field_grehigh_to_MNI152
	cmd = "fnirtfileutils --in="+Folder+"NIFTI/coef_grehigh_to_MNI152 --ref=/usr/local/fsl/data/standard/MNI152_T1_1mm --withaff --out=";
	cmd += Folder + "NIFTI/field_grehigh_to_MNI152";
	std::cout << cmd << std::endl;
	system(cmd.c_str());

}

#if 0
void qFSLProcessing::startFSLBatch(std::string Folder) {

	std::string cmd;

	// bet /home/neeb/bv/data/MSKO/KOMS0004/NIFTI/gre_highflip.nii /home/neeb/bv/data/MSKO/KOMS0004/NIFTI/gre_highflip_Brain -f 0.35
	cmd = "bet "+Folder + "NIFTI/gre_highflip.nii" + " " + Folder + "NIFTI/gre_highflip_Brain -f 0.35";
	std::cout << cmd << std::endl;
	system(cmd.c_str());

	// flirt -in /home/neeb/bv/data/MSKO/KOMS0004/NIFTI/gre_highflip_Brain.nii.gz -ref /usr/share/fsl/data/standard/MNI152_T1_1mm_brain -dof 12 -cost corratio -out /home/neeb/bv/data/MSKO/KOMS0004/NIFTI/flirted_grehighflip_Brain -omat /home/neeb/bv/data/MSKO/KOMS0004/NIFTI/gre_highflip_to_MNI152.mat
	cmd = "flirt -in "+Folder+"/NIFTI/gre_highflip_Brain.nii.gz -ref /usr/share/fsl/data/standard/MNI152_T1_1mm_brain -dof 12 -cost corratio -out ";
	cmd += Folder + "NIFTI/flirted_grehighflip_Brain -omat "+ Folder +"NIFTI/gre_highflip_to_MNI152.mat";
	std::cout << cmd << std::endl;
	system(cmd.c_str());

	// fnirt
	cmd = "fnirt --in="+Folder+"/NIFTI/gre_highflip.nii --aff="+Folder+"/NIFTI/gre_highflip_to_MNI152.mat --config=/home/neeb/fsl/Patient_to_MNI_Final.cnf";
	cmd += " --cout="+Folder+"/NIFTI/coef_grehigh_to_MNI152 --iout="+Folder+"NIFTI/fnirted_grehighflip --jout=";
	cmd += Folder+"NIFTI/jac_grehigh_to_MNI152 --jacrange=0.1,10";
	std::cout << cmd << std::endl;
	system(cmd.c_str());

	// applywarp -i gre_highflip.nii -r /usr/share/fsl/data/standard/MNI152_T1_1mm -o /home/neeb/bv/data/MSKO/KOMS0004/NIFTI/HD_fnirted_grehighflip
	cmd = "applywarp -i "+Folder+"NIFTI/gre_highflip.nii -r /usr/share/fsl/data/standard/MNI152_T1_1mm -o "+Folder+"NIFTI/HD_fnirted_grehighflip";
	std::cout << cmd << std::endl;
	//system(cmd.c_str());

	// fnirtfileutils --in=/home/neeb/bv/data/MSKO/KOMS0004/NIFTI/coef_grehigh_to_MNI152 --ref=/usr/share/fsl/data/standard/MNI152_T1_1mm --out=/home/neeb/bv/data/MSKO/KOMS0004/NIFTI/field_grehigh_to_MNI152_nonlinear_only
	cmd = "fnirtfileutils --in="+Folder+"NIFTI/coef_grehigh_to_MNI152 --ref=/usr/share/fsl/data/standard/MNI152_T1_1mm --out=";
	cmd += Folder+"NIFTI/field_grehigh_to_MNI152_nonlinear_only";
	std::cout << cmd << std::endl;
	system(cmd.c_str());

	// fnirtfileutils --in=/home/neeb/bv/data/MSKO/KOMS0004/NIFTI/coef_grehigh_to_MNI152 --ref=/usr/share/fsl/data/standard/MNI152_T1_1mm --withaff --out=/home/neeb/bv/data/MSKO/KOMS0004/NIFTI/field_grehigh_to_MNI152
	cmd = "fnirtfileutils --in="+Folder+"NIFTI/coef_grehigh_to_MNI152 --ref=/usr/share/fsl/data/standard/MNI152_T1_1mm --withaff --out=";
	cmd += Folder + "NIFTI/field_grehigh_to_MNI152";
	std::cout << cmd << std::endl;
	system(cmd.c_str());

}
#endif
