//  File name: $HeadURL: https://www.rheinahrcampus.de/svn/repos/predict4a/pLib/src/qIOUtils.cpp $
//  Revision: $Revision: 54 $
//  Last modified: $Date: 2012-06-01 09:34:24 +0200 (Fr, 01 Jun 2012) $
//  Last modified by: $Author: neeb $

/*
 * qIOUtils.cpp
 *
 *  Created on: 11.10.2011
 *      Author: neeb

	Copyright 2012 Heiko Neeb

    This file is part of PREDICT-MS (Professional Remagen Diagnostic Image Calculation Tool for MS).

    PREDICT-MS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    PREDICT-MS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with "predict".  If not, see <http://www.gnu.org/licenses/>.

	PREDICT-MS is designed to be used for scientific purposes only. Do NOT
	base any diagnosis on the results obtained with this program

	The software is based on the following work which the authors kindly ask to reference in
	any scientific work which is based on PREDICT-MS or parts of it:

	V. Tonkova, V. Arhelger, J. Schenk, H. Neeb. Rapid Myelin Water Content Mapping on Clinical MR Systems.
	Z Med Phys (2012): http://dx.doi.org/10.1016/j.zemedi.2011.09.005

	H. Neeb, V. Ermer, T. Stocker, N.J. Shah. Fast quantitative mapping of absolute water content
	with full brain coverage. NeuroImage (2008). 42(3): 10941109

 */

#include "qIOUtils.h"
#include <iostream>
#include <algorithm>
#include <string>

#include <dirent.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>


qIOUtils::qIOUtils() {
	// TODO Auto-generated constructor stub

}

qIOUtils::~qIOUtils() {
	// TODO Auto-generated destructor stub
}


// taken from : http://www.cplusplus.com/forum/unices/3548/
std::list <std::string> qIOUtils::read_directory( const std::string& path = std::string() )
{
	std::list <std::string> result;
	dirent* de;
	DIR* dp;
	errno = 0;
	dp = opendir( path.empty() ? "." : path.c_str() );
	if (dp)
	{
		while (true)
		{
			errno = 0;
			de = readdir( dp );
			if (de == NULL) break;
			result.push_back(std::string( de->d_name ));
		}
		closedir( dp );
		result.sort();
	}
	return result;
}


bool qIOUtils::create_empty_directory( const std::string& path ) {

#ifdef IS_WINDOWS
	std::string cmd="del "+path+"\\*";
	system(cmd.c_str());
	cmd="rmdir "+path;
	system(cmd.c_str());
#else
	std::string cmd="rm -rf "+path;
	system(cmd.c_str());
#endif

	if( mkdir(path.c_str(),-1) != 0 ) {
#ifdef IS_WINDOWS
#else
		std::cout << "Error: could not create folder : " << path <<std::endl;
		return false;
#endif
	}
	return true;
}

