//  File name: $HeadURL: https://www.rheinahrcampus.de/svn/repos/predict4a/pLib/src/qRecon.cpp $
//  Revision: $Revision: 53 $
//  Last modified: $Date: 2012-05-02 10:46:15 +0200 (Mi, 02 Mai 2012) $
//  Last modified by: $Author: neeb $

/*
 * qRecon.cpp
 *
 *  Created on: 06.09.2011
 *      Author: neeb

	Copyright 2012 Heiko Neeb

    This file is part of PREDICT-MS (Professional Remagen Diagnostic Image Calculation Tool for MS).

    PREDICT-MS is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    PREDICT-MS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with "predict".  If not, see <http://www.gnu.org/licenses/>.

	PREDICT-MS is designed to be used for scientific purposes only. Do NOT
	base any diagnosis on the results obtained with this program

 	The software is based on the following work which the authors kindly ask to reference in
	any scientific work which is based on PREDICT-MS or parts of it:

	V. Tonkova, V. Arhelger, J. Schenk, H. Neeb. Rapid Myelin Water Content Mapping on Clinical MR Systems.
	Z Med Phys (2012): http://dx.doi.org/10.1016/j.zemedi.2011.09.005

	H. Neeb, V. Ermer, T. Stocker, N.J. Shah. Fast quantitative mapping of absolute water content
	with full brain coverage. NeuroImage (2008). 42(3): 10941109

 */

#include "qRecon.h"
#include <list>
#include <boost/shared_ptr.hpp>

qRecon::qRecon() {
	nSlices = 0;
	nRow = 0;
	nCol = 0;
}

qRecon::~qRecon() {
	// TODO Auto-generated destructor stub
}


void qRecon::addMask(std::list< boost::shared_ptr<qImage> > &secondMask) {

	std::list< boost::shared_ptr<qImageBinMask> >::iterator iter;
	std::list< boost::shared_ptr<qImage> >::iterator iterSec(secondMask.begin());

	// Check if mask has already been created. If not, assign.
	if(mask.size() == 0 ) {
		// copy mask slice by slice (required because a static_cast is neccessary
	    for(iterSec=secondMask.begin(); iterSec!=secondMask.end(); iterSec++)
	    	mask.push_back(boost::static_pointer_cast<qImageBinMask>(*iterSec));
	}
	else {
		if( mask.size() != secondMask.size() ) {
			throw "qRecon::addMask : incompatible mask dimensions";
		}

		// add new mask to existing mask slice by slice
	    for(iter=mask.begin(); iter!=mask.end(); iter++, iterSec++)
	    	(*iter)->OR(**iterSec);
	}
}


void qRecon::removeMask(std::list< boost::shared_ptr<qImage> > &secondMask) {
//	secondMask.invert();
//	mask.AND(secondMask);
//	secondMask.invert();
}


